searchNodes=[{"doc":"The LiveSelect component is rendered by calling the live_select/3 function and passing it a form and the name of the field. LiveSelect creates a text input field in which the user can type text, and hidden input field(s) that will contain the value of the selected option(s). As the input text changes, LiveSelect will render a dropdown below the text input containing the matching options, which the user can then select. Selection can happen either using the keyboard, by navigating the options with the arrow keys and then pressing enter, or by clicking an option with the mouse. Whenever an option is selected, LiveSelect will trigger a standard phx-change event in the form. See the &quot;Examples&quot; section below for details on how to handle the event. In single mode, if the configuration option allow_clear is set, the user can manually clear the selection by clicking on the x button on the input field. In tags mode, single tags can be removed by clicking on them. Single mode Tags mode Options You can pass or update the list of options the user can choose from with the options assign. Each option will be assigned a label, which will be shown in the dropdown, and a value, which will be the value of the LiveSelect input when the option is selected. options can be any enumeration of the following elements: atoms, strings or numbers : In this case, each element will be both label and value for the option tuples : {label, value} corresponding to label and value for the option maps : %{label: label, value: value} or %{value: value} keywords : [label: label, value: value] or [value: value] In the case of maps and keywords, if only value is specified, it will be used as both value and label for the option. Because you can pass a list of tuples, you can use maps and keyword lists to pass the list of options, for example: %{ Red : 1 , Yellow : 2 , Green : 3 } Will result in 3 options with labels :Red , :Yellow , :Green and values 1, 2, and 3. Note that the option values, if they are not strings, will be JSON-encoded. Your LiveView will receive this JSON-encoded version in the phx-change and phx-submit events. Alternative tag labels Sometimes, in :tags mode, you might want to use alternative labels for the tags. For example, you might want the labels in the tags to be shorter in order to save space. You can do this by specifying an additional tag_label key when passing options as map or keywords. For example, passing these options: [ %{ label : &quot;New York&quot; , tag_label : &quot;NY&quot; } , %{ label : &quot;Barcelona&quot; , tag_label : &quot;BCN&quot; } ] will result in &quot;New York&quot; and &quot;Barcelona&quot; being used for the options in the dropdown, while &quot;NY&quot; and &quot;BCN&quot; will be used for the tags. Reacting to user's input Whenever the user types something in the text input, LiveSelect sends a LiveSelect.ChangeMsg.t/0 message to your LiveView. The message has a text property containing the current text entered by the user, as well as id and field properties with the id of the LiveSelect component and the name of the LiveSelect form field, respectively. The LiveView's job is to handle_info/2 the message and then call LiveView.send_update/3 to update the list of selectable options. See the &quot;Examples&quot; section below for details. Multiple selection with tags mode When :tags mode is enabled LiveSelect allows the user to select multiple entries. The entries will be visible above the text input field as removable tags. The selected entries will be passed to your live view's change and submit event handlers as a list of entries, just like an HTML &lt;select&gt; element with multiple attribute would do. Clearing the selection programmatically You can clear the selection programmatically by sending a clear: true assign to LiveSelect send_update ( LiveSelect.Component , id : live_select_id , clear : true ) To set a custom id for the component, use the id option when calling live_select/3 . Examples These examples describe all the moving parts in detail. You can see these examples in action, see which messages and events are being sent, and play around with the configuration easily with the showcase app . Single mode The user can search for cities. The LiveSelect main form input is called city_search . When a city is selected, the coordinates of that city will be the value of the form input. The name of the selected city is available in the text input field named city_search_text_input . Template: &lt; . form for = { :my_form } :let = { f } phx - change = &quot;change&quot; &gt; &lt; % = live_select f , :city_search % &gt; &lt; / . form &gt; LiveView: import LiveSelect @impl true def handle_info ( % LiveSelect.ChangeMsg { } = change_msg , socket ) do cities = City . search ( change_msg . text ) # cities could be: # [ {&quot;city name 1&quot;, [lat_1, long_1]}, {&quot;city name 2&quot;, [lat_2, long_2]}, ... ] # # but it could also be (no coordinates in this case): # [ &quot;city name 1&quot;, &quot;city name 2&quot;, ... ] # # or: # [ [label: &quot;city name 1&quot;, value: [lat_1, long_1]], [label: &quot;city name 2&quot;, value: [lat_2, long_2]], ... ] # # or even: # [&quot;city name 1&quot;: [lat_1, long_1], &quot;city name 2&quot;: [lat_2, long_2]] send_update ( LiveSelect.Component , id : change_msg . id , options : cities ) { :noreply , socket } end @impl true def handle_event ( &quot;change&quot; , %{ &quot;my_form&quot; =&gt; %{ &quot;city_search_text_input&quot; =&gt; city_name , &quot;city_search&quot; =&gt; city_coords } } , socket ) do IO . puts ( &quot;You selected city \#{ city_name } located at: \#{ city_coords } &quot; ) { :noreply , socket } end Tags mode Let's say you want to build on the previous example and allow the user to select multiple cities and not only one. The :tags mode allows you to do exactly this. Template: &lt; . form for = { :my_form } :let = { f } phx - change = &quot;change&quot; &gt; &lt; % = live_select f , :city_search , mode : :tags % &gt; &lt; / . form &gt; LiveView: @impl true def handle_event ( &quot;change&quot; , %{ &quot;my_form&quot; =&gt; %{ &quot;city_search&quot; =&gt; list_of_coords } } , socket ) do # list_of_coords will contain the list of the JSON-encoded coordinates of the selected cities, for example: # [&quot;[-46.565,-23.69389]&quot;, &quot;[-48.27722,-18.91861]&quot;] IO . puts ( &quot;You selected cities located at: \#{ list_of_coords } &quot; ) { :noreply , socket } end Multiple LiveSelect inputs in the same LiveView If you have multiple LiveSelect inputs in the same LiveView, you can distinguish them based on the field or id. For example: Template: &lt; . form for = { :my_form } :let = { f } phx - change = &quot;change&quot; &gt; &lt; % = live_select f , :city_search % &gt; &lt; % = live_select f , :album_search % &gt; &lt; / . form &gt; LiveView: @impl true def handle_info ( % LiveSelect.ChangeMsg { } = change_msg , socket ) do options = case change_msg . field do :city_search -&gt; City . search ( change_msg . text ) :album_search -&gt; Album . search ( change_msg . text ) end send_update ( LiveSelect.Component , id : change_msg . id , options : options ) { :noreply , socket } end","ref":"LiveSelect.html","title":"LiveSelect","type":"module"},{"doc":"Renders a LiveSelect input in a form with a given field name. LiveSelect renders two inputs: a hidden input (of type either text or select, depending on the specified mode) named field that holds the value of the selected option(s), and a visible text input field named \#{field}_text_input that contains the text entered by the user. Opts: id - an id to assign to the component. If none is provided, \#{form_name}_\#{field_name}_component will be used mode - either :single (for single selection, the default), or :tags (for multiple selection using tags) options - initial available options to select from. See the &quot;Options&quot; section for details on what you can pass here value - used to manually set an initial selection - overrides any values from the form. Must be a single element in :single mode, or a list of elements in :tags mode. If an element can be found in the initial options, the corresponding label will be used. Otherwise, the element will be used for both value and label max_selectable - limits the maximum number of selectable elements. Defaults to 0 , meaning no limit user_defined_options - if true , hitting enter will always add the text entered by the user to the selection. Defaults to false allow_clear - if true , when in single mode, display a &quot;x&quot; button in the input field to clear the selection disabled - set this to true to disable the input field placeholder - placeholder text for the input field debounce - number of milliseconds to wait after the last keystroke before sending a LiveSelect.ChangeMsg.t/0 message. Defaults to 100ms update_min_len - the minimum length of text in the text input field that will trigger an update of the dropdown. It has to be a positive integer. Defaults to 3 style - one of :tailwind (the default), :daisyui or :none . See the Styling section for details active_option_class , available_option_class , container_class , container_extra_class , dropdown_class , dropdown_extra_class , option_class , option_extra_class , text_input_class , text_input_extra_class , text_input_selected_class , selected_option_class , tag_class , tag_extra_class , tags_container_class , tags_container_extra_class - see the Styling section for details","ref":"LiveSelect.html#live_select/3","title":"LiveSelect.live_select/3","type":"function"},{"doc":"Updates a LiveSelect component with new options. change_msg must be the LiveSelect.ChangeMsg.t/0 originally sent by the LiveSelect, and options is the new list of options that will be used to fill the dropdown.","ref":"LiveSelect.html#update_options/2","title":"LiveSelect.update_options/2","type":"function"},{"doc":"LiveSelect.ChangeMsg","ref":"LiveSelect.ChangeMsg.html","title":"LiveSelect.ChangeMsg","type":"module"},{"doc":"Message sent by LiveSelect components in response to text entered by the user in the text input field","ref":"LiveSelect.ChangeMsg.html#t:t/0","title":"LiveSelect.ChangeMsg.t/0","type":"type"},{"doc":"The module that implements the LiveSelect live component","ref":"LiveSelect.Component.html","title":"LiveSelect.Component","type":"module"},{"doc":"","ref":"LiveSelect.Component.html#maybe_save_selection/1","title":"LiveSelect.Component.maybe_save_selection/1","type":"function"},{"doc":"Callback implementation for Phoenix.LiveComponent.render/1 .","ref":"LiveSelect.Component.html#render/1","title":"LiveSelect.Component.render/1","type":"function"},{"doc":"Dynamic selection field for LiveView. LiveSelect is a LiveView component that implements a dynamic selection field with a dropdown. The content of the dropdown is filled dynamically by your LiveView as a reaction to user's input. This allows you to easily create an interface for features such as search. It supports both single and multiple selections. Try it in the showcase app 🔬 Single selection (single mode) Multiple selection (tags mode)","ref":"readme.html","title":"Readme","type":"extras"},{"doc":"Template: &lt; . form for = { :my_form } :let = { f } phx - change = &quot;change&quot; &gt; &lt; % = live_select f , :city_search % &gt; &lt; / . form &gt; LiveView: import LiveSelect @impl true def handle_info ( % LiveSelect.ChangeMsg { } = change_msg , socket ) do cities = City . search ( change_msg . text ) # cities = [ # {&quot;New York City&quot;, [-74.00597,40.71427]}, # {&quot;New Kingston&quot;, [-76.78319,18.00747]}, # ... # ] send_update ( LiveSelect.Component , id : change_msg . id , options : cities ) { :noreply , socket } end @impl true def handle_event ( &quot;change&quot; , %{ &quot;my_form&quot; =&gt; %{ &quot;city_search_text_input&quot; =&gt; city_name , &quot;city_search&quot; =&gt; city_coords } } , socket ) do IO . puts ( &quot;You selected city \#{ city_name } located at: \#{ city_coords } &quot; ) { :noreply , socket } end Refer to the module documentation for the nitty-gritty details.","ref":"readme.html#usage","title":"Readme - Usage 🧭","type":"extras"},{"doc":"To install, add this to your dependencies: [ { :live_select , &quot;~&gt; 0.4.0&quot; } ]","ref":"readme.html#installation","title":"Readme - Installation 📦","type":"extras"},{"doc":"LiveSelect relies on Javascript hooks to work. You need to add LiveSelect 's hooks to your live socket. In your app.js file: import live_select from &quot;live_select&quot; // if you don't have any other hooks: let liveSocket = new LiveSocket(&quot;/live&quot;, Socket, {params: {_csrf_token: csrfToken}, hooks: live_select}) // if you have other hooks: const hooks = { MyHook: { // ... }, ...live_select } let liveSocket = new LiveSocket(&quot;/live&quot;, Socket, {params: {_csrf_token: csrfToken}, hooks})","ref":"readme.html#javascript-hooks","title":"Readme - Javascript hooks 🪝","type":"extras"},{"doc":"LiveSelect supports 3 styling modes: tailwind : uses standard tailwind utility classes (the default) daisyui : uses daisyUI classes. none : no styling at all. The choice of style is controlled by the style option in live_select/3 . tailwind and daisyui styles come with sensible defaults which can be selectively extended or completely overridden. If you're using tailwind or daisyui styles, you need to add one of the following lines to the content section in your tailwind.config.js : module.exports = { content: [ //... '../deps/live_select/lib/live_select/component.*ex', // &lt;-- for a standalone app '../../../deps/live_select/lib/live_select/component.*ex' // &lt;-- for an umbrella app ] //.. } Notice the different paths for a standalone or umbrella app. Refer to the Styling section for further details.","ref":"readme.html#tailwind-configuration","title":"Readme - Tailwind configuration 🎨","type":"extras"},{"doc":"The repository includes a showcase app that you can use to experiment with the different options and parameters for LiveSelect . The showcase app is available here . To start the showcase app locally, simply run: mix setup PORT = 4001 mix phx . server from within the cloned repository. The app will be available at http://localhost:4001 . The showcase app allows you to quickly experiment with options and styles, providing an easy way to fine tune your LiveSelect component. The app also shows the messages and events that your LiveView receives. For each event or message, the app shows the function head of the callback that your LiveView needs to implement in order to handle the event.","ref":"readme.html#showcase-app","title":"Readme - Showcase app 🎪","type":"extras"},{"doc":"Contributions are very welcome! Use mix test to run the entire test suite, which is subdivided into 3 main files: test/live_select/component_test.exs - everything that can be tested by rendering the component statically test/live_select_test.exs - tests for single mode that require a running LiveView test/live_select_tags_test.exs - tests for tags mode that require a running LiveView Tests that require a LiveView use the showcase app as the parent LiveView.","ref":"readme.html#contribute","title":"Readme - Contribute 🤝","type":"extras"},{"doc":"[X] Add package.json to enable import live_select from &quot;live_select&quot; [X] Make sure component classes are included by tailwind [X] Enable custom styling [X] Rename LiveSelect.render to live_select [X] Customizable placeholder [X] Enable configuration of styles in the showcase app [X] Add support for vanilla tailwind styles [X] Enable multiple selection mode [ ] Expose as function component (and drop LV 0.17 support) [ ] Maybe additional multiple selection mode(s)?","ref":"readme.html#roadmap","title":"Readme - Roadmap 🛣️","type":"extras"},{"doc":"LiveSelect supports 3 styling modes: tailwind : uses standard tailwind utility classes (the default) daisyui : uses daisyUI classes. none : no styling at all. The choice of style is controlled by the style option in live_select/3 . tailwind and daisyui styles come with sensible defaults which can be extended or overridden via options. This is what each default style looks like: daisyui: (the actual colors may differ depending on the selected daisyui theme ) tailwind: These defaults can be selectively overridden or extended using the appropriate options to live_select/3 . You can control the style of the following elements: The outer container of the live_select component The text input field The text input field when an option has been selected The dropdown that contains the selectable options The single selectable option (s) The currently active option Here's a visual representation of the elements: In tags mode there are 4 additional stylable elements: The tag showing the selected options The tags_container that contains the tags selected_option . This is an option in the dropdown that has already been selected. It's still visible, but can't be selected again available_option . This is an option in the dropdown that has not been selected and is available for selection For each of these elements there is an {element}_class and for some also an {element}_extra_class option, which can be used to override or extend the default CSS classes for the element, respectively. You can't use both options together: use {element}_class to completely override the default classes, or use {element}_extra_class to extend the default. The following table shows the default styles for each element and the options you can use to adjust its CSS classes. Element Default daisyui classes Default tailwind classes Class override option Class extend option active_option active bg-gray-600 text-white active_option_class available_option cursor-pointer cursor-pointer hover:bg-gray-400 rounded available_option_class container dropdown dropdown-open h-full relative text-black container_class container_extra_class dropdown bg-base-200 dropdown-content menu menu-compact p-1 rounded-box shadow w-full absolute bg-gray-100 rounded-md shadow w-full z-50 dropdown_class dropdown_extra_class option px-4 py-1 rounded option_class option_extra_class selected_option disabled text-gray-400 selected_option_class tag badge badge-primary p-1.5 text-sm bg-blue-400 flex p-1 rounded-lg text-sm tag_class tag_extra_class tags_container flex flex-wrap gap-1 p-1 flex flex-wrap gap-1 p-1 tags_container_class tags_container_extra_class text_input input input-bordered pr-6 w-full disabled:bg-gray-100 disabled:placeholder:text-gray-400 disabled:text-gray-400 pr-6 rounded-md w-full text_input_class text_input_extra_class text_input_selected input-primary border-gray-600 text-gray-600 text_input_selected_class For example, if you want the options to use black text, the active option to have a red background, and remove rounded borders from both the dropdown and the active option, call live_select/3 like this: live_select ( form , field , active_option_class : &quot;text-white bg-red-800&quot; , dropdown_extra_class : &quot;!rounded-xl&quot; , option_extra_class : &quot;!rounded-lg text-black&quot; , style : :tailwind ) Selectively removing classes from defaults You can remove classes included with the style's defaults by using the !class_name notation in an {element}_extra_class option. For example, if a default style is rounded-lg px-4 , using an extra class option of !rounded-lg text-black will result in the following final class being applied to the element: px-4 text-black","ref":"styling.html","title":"Styling","type":"extras"},{"doc":"","ref":"changelog.html","title":"CHANGELOG","type":"extras"},{"doc":"Bugfix: component now works event when strict Content Security Policy are set","ref":"changelog.html#0-4-1-2023-02-07","title":"CHANGELOG - 0.4.1 (2023-02-07)","type":"extras"},{"doc":"add available_option_class configuration option to style options that have not been selected yet add user_defined_options configuration option to allow user to enter any tag enable assigning a custom id to the component enable programmatically clearing of the selection via clear assign add allow_clear configuration option. If set, an x button will appear next to the text input in single mode. Clicking the button clears the selection Deprecations LiveSelect.update_options/2 has been deprecated in favor of directly using Phoenix.LiveView.send_update/3","ref":"changelog.html#0-4-0-2023-01-30","title":"CHANGELOG - 0.4.0 (2023-01-30)","type":"extras"},{"doc":"set initial selection from the form or manually with value option set initial list of available options with options option add a max_selectable option to limit the maximum size of the selection","ref":"changelog.html#0-3-3-2023-01-15","title":"CHANGELOG - 0.3.3 (2023-01-15)","type":"extras"},{"doc":"Bugfix: options in dropdown not always clickable because of race condition with blur event ( https://github.com/maxmarcon/live_select/issues/7 )","ref":"changelog.html#0-3-2-2023-01-03","title":"CHANGELOG - 0.3.2 (2023-01-03)","type":"extras"},{"doc":"Bugfix: removed inputs_for because it was failing if the field is not an association","ref":"changelog.html#0-3-1-2022-12-15","title":"CHANGELOG - 0.3.1 (2022-12-15)","type":"extras"},{"doc":"tags mode hide dropdown on escape key pressed","ref":"changelog.html#0-3-0-2022-12-15","title":"CHANGELOG - 0.3.0 (2022-12-15)","type":"extras"},{"doc":"when disabled option is used, also disable hidden input style disabled text input in tailwind mode fix problem with selection via mouseclick when an input field is underneath the dropdown hide dropdown when user clicks away from component or input loses focus show dropdown when input obtains focus again using default black text in tailwind mode","ref":"changelog.html#0-2-1-2022-10-25","title":"CHANGELOG - 0.2.1 (2022-10-25)","type":"extras"},{"doc":"support for tailwind styles (now the default) more opinionated default styles ability to selectively remove classes from style defaults using the !class_name notation rename option search_term_min_length to update_min_len better error messages various improvements to the showcase app","ref":"changelog.html#0-2-0-2022-10-03","title":"CHANGELOG - 0.2.0 (2022-10-03)","type":"extras"},{"doc":"raise if class and extra_class options are used in invalid combinations ( https://github.com/maxmarcon/live_select/issues/2 ) Bugfixes route server events to the right live select component using the component id ( https://github.com/maxmarcon/live_select/issues/1 )","ref":"changelog.html#0-1-4-2022-09-20","title":"CHANGELOG - 0.1.4 (2022-09-20)","type":"extras"},{"doc":"rename LiveSelect.update/2 to LiveSelect.update_options/2 add debounce option add search delay option to showcase app JSON-encode option values before assigning them to the hidden input field add LiveSelect.ChangeMsg struct to be used as change message","ref":"changelog.html#0-1-3-2022-08-12","title":"CHANGELOG - 0.1.3 (2022-08-12)","type":"extras"},{"doc":"Disable input field via options Placeholder text via options Improve docs and showcase app Remove setting component id via options Bugfixes Use atoms as field names, because strings are not accepted by Ecto forms","ref":"changelog.html#0-1-2-2022-08-10","title":"CHANGELOG - 0.1.2 (2022-08-10)","type":"extras"},{"doc":"Remove all colors from default daisyui styles Improve styling of showcase app Improve docs Remove the msg_prefix option in favor of change_msg","ref":"changelog.html#0-1-1-2022-08-09","title":"CHANGELOG - 0.1.1 (2022-08-09)","type":"extras"},{"doc":"First version 🎉","ref":"changelog.html#0-1-0-2022-08-09","title":"CHANGELOG - 0.1.0 (2022-08-09)","type":"extras"}]